/*
Authorization Service API v. 1.0

<a href='https://cern.service-now.com/service-portal?id=privacy_policy&se=SSO-Service&notice=resources'>Privacy notice</a>

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package authzapiv1

import (
	"encoding/json"
	"fmt"
)

// IdentityType the model 'IdentityType'
type IdentityType string

// List of IdentityType
const (
	IDENTITYTYPE_UNDEFINED   IdentityType = "Undefined"
	IDENTITYTYPE_PERSON      IdentityType = "Person"
	IDENTITYTYPE_APPLICATION IdentityType = "Application"
	IDENTITYTYPE_SERVICE     IdentityType = "Service"
	IDENTITYTYPE_SECONDARY   IdentityType = "Secondary"
)

// All allowed values of IdentityType enum
var AllowedIdentityTypeEnumValues = []IdentityType{
	"Undefined",
	"Person",
	"Application",
	"Service",
	"Secondary",
}

func (v *IdentityType) UnmarshalJSON(src []byte) error {
	var value string
	err := json.Unmarshal(src, &value)
	if err != nil {
		return err
	}
	enumTypeValue := IdentityType(value)
	for _, existing := range AllowedIdentityTypeEnumValues {
		if existing == enumTypeValue {
			*v = enumTypeValue
			return nil
		}
	}

	return fmt.Errorf("%+v is not a valid IdentityType", value)
}

// NewIdentityTypeFromValue returns a pointer to a valid IdentityType
// for the value passed as argument, or an error if the value passed is not allowed by the enum
func NewIdentityTypeFromValue(v string) (*IdentityType, error) {
	ev := IdentityType(v)
	if ev.IsValid() {
		return &ev, nil
	} else {
		return nil, fmt.Errorf("invalid value '%v' for IdentityType: valid values are %v", v, AllowedIdentityTypeEnumValues)
	}
}

// IsValid return true if the value is valid for the enum, false otherwise
func (v IdentityType) IsValid() bool {
	for _, existing := range AllowedIdentityTypeEnumValues {
		if existing == v {
			return true
		}
	}
	return false
}

// Ptr returns reference to IdentityType value
func (v IdentityType) Ptr() *IdentityType {
	return &v
}

type NullableIdentityType struct {
	value *IdentityType
	isSet bool
}

func (v NullableIdentityType) Get() *IdentityType {
	return v.value
}

func (v *NullableIdentityType) Set(val *IdentityType) {
	v.value = val
	v.isSet = true
}

func (v NullableIdentityType) IsSet() bool {
	return v.isSet
}

func (v *NullableIdentityType) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableIdentityType(val *IdentityType) *NullableIdentityType {
	return &NullableIdentityType{value: val, isSet: true}
}

func (v NullableIdentityType) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableIdentityType) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
